---
title: PushSubscription.getKey()
slug: Web/API/PushSubscription/getKey
tags:
  - API
  - Experimental
  - Method
  - Push
  - Push API
  - PushSubscription
  - Reference
  - Service Workers
  - getKey
---
<p>{{SeeCompatTable}}{{APIRef("Push API")}}</p>

<p>The <code>getKey()</code> method of the {{domxref("PushSubscription")}} interface returns an {{domxref("ArrayBuffer")}} representing a client public key, which can then be sent to a server and used in encrypting push message data.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><span class="pl-k">var</span> key <span class="pl-k">=</span> subscription.getKey(<span class="pl-s"><span class="pl-pds">name</span></span>);</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt>name</dt>
 <dd>A {{domxref("DOMString")}} representing the encryption method used to generate a client key.  The value can be:
 <ul>
  <li><code>p256dh</code>: An <a href="https://en.wikipedia.org/wiki/Elliptic_curve_Diffie%E2%80%93Hellman">Elliptic curve Diffie–Hellman</a> public key on the P-256 curve (that is, the NIST secp256r1 elliptic curve).  The resulting key is an uncompressed point in ANSI X9.62 format.</li>
  <li><code>auth</code>: An authentication secret, as described in<span class="h1"> <a href="https://tools.ietf.org/html/draft-ietf-webpush-encryption-08">Message Encryption for Web Push</a>.</span></li>
 </ul>
 </dd>
</dl>

<h3 id="Returns">Returns</h3>

<p>An {{domxref("ArrayBuffer")}}.</p>

<h2 id="Example">Example</h2>

<pre class="brush: js">reg.pushManager.getSubscription()
  .then(function(subscription) {
  // Enable any UI which subscribes / unsubscribes from
  // push messages.

  subBtn.disabled = false;

  if (!subscription) {
    console.log('Not yet subscribed to Push')
    // We aren't subscribed to push, so set UI
    // to allow the user to enable push
    return;
  }

  // Set your UI to show they have subscribed for
  // push messages
  subBtn.textContent = 'Unsubscribe from Push Messaging';
  isPushEnabled = true;

  // initialize status, which includes setting UI elements for subscribed status
  // and updating Subscribers list via push
  var endpoint = subscription.endpoint;
  var key = subscription.getKey('p256dh');
  var auth = subscription.getKey('auth');

    ...</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Push API')}}</td>
   <td>{{Spec2('Push API')}}</td>
   <td>This is the Push API spec, but note that <code>getKey()</code> is not currently specified in here. It is currently Firefox-only experimental.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_Compatibility">Browser Compatibility</h2>

<div>

<p>{{Compat("api.PushSubscription.getKey")}}</p>
</div>
